"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/* eslint-disable no-plusplus */
var fs_1 = require("fs");
/**
 * 向指定文件添加内容
 *
 * @param {string} targetFilePath
 * @param {(...(string | ReadStream)[])} contents
 */
function appendContentToFile(targetFilePath) {
    var contents = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        contents[_i - 1] = arguments[_i];
    }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var writer, append, i;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    writer = fs_1.createWriteStream(targetFilePath, {
                        flags: 'a',
                    });
                    append = function (content, end) {
                        if (end === void 0) { end = false; }
                        return new Promise(function (resolve, reject) {
                            if (typeof content === 'string') {
                                var cb = function (error) {
                                    if (error) {
                                        reject(error);
                                    }
                                    else {
                                        resolve();
                                    }
                                };
                                if (end) {
                                    writer.end(content, cb);
                                }
                                writer.write(content, cb);
                            }
                            else {
                                var stream = content.pipe(writer, {
                                    end: end,
                                });
                                content.on('end', function () {
                                    resolve();
                                });
                                stream.on('error', function (error) {
                                    reject(error);
                                });
                            }
                        });
                    };
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < contents.length)) return [3 /*break*/, 4];
                    // eslint-disable-next-line no-await-in-loop
                    return [4 /*yield*/, append(contents[i], i === contents.length - 1)];
                case 2:
                    // eslint-disable-next-line no-await-in-loop
                    _a.sent();
                    _a.label = 3;
                case 3:
                    i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.default = appendContentToFile;
//# sourceMappingURL=appendContentToFile.js.map